<script setup>
import { CdxField, CdxTextInput, CdxMessage, CdxMultiselectLookup, CdxCheckbox } from '@wikimedia/codex';
import { useInstrumentStore } from '../../stores/instrument.js'
import { ref } from 'vue'

const instrumentStore = useInstrumentStore();

let complianceRequirements = []
if ((instrumentStore.instrument.compliance_requirements !== undefined) && (instrumentStore.instrument.compliance_requirements !== '')) {
    complianceRequirements = instrumentStore.instrument.compliance_requirements.split(',')
}
const complianceRequirementsChips = ref( complianceRequirements.map( item => ({ label: item, value: item })) )
const complianceRequirementsSelection = ref( complianceRequirements )
const complianceRequirementsMenuItems = ref( [] )
const complianceRequirementsItems = [
    {label: 'legal', value: 'legal'},
    {label: 'gdpr', value: 'gdpr'}
];

function onComplianceRequirementsInput( value ) {
    if ( value ) {
        complianceRequirementsMenuItems.value = complianceRequirementsItems.filter((item ) => 
            item.label.toLocaleLowerCase().includes( value.toLocaleLowerCase() )
        )
    } else {
        complianceRequirementsMenuItems.value = []
    }
}

function onComplianceRequirementsChanged ( newSet ) {
    instrumentStore.instrument.compliance_requirements = Array.from(newSet).join(',');
}
</script>

<template>
    <div>
        <h2>Regulation</h2>
        <cdx-message>
            Data will be automatically discarded after 90 days of storage.
        </cdx-message>

        <!-- REGULATION: Security and Legal -->
        <cdx-field>
            <cdx-text-input
                v-model="instrumentStore.instrument.security_legal_review"
                data-id="security-legal-review"
            />
            <template #label>
                Security and Legal
            </template>
            <template #description>
                Provide a link to the review provided by the Security and Legal department.
            </template>
        </cdx-field>

        <!-- REGULATION: Compliance requirements -->
        <cdx-field>
            <cdx-multiselect-lookup
                v-model:input-chips="complianceRequirementsChips"
                v-model:selected="complianceRequirementsSelection"
                :menu-items="complianceRequirementsMenuItems"
                data-id="compliance-requirements"
                @input="onComplianceRequirementsInput"
                @update:selected="onComplianceRequirementsChanged($event)"
            />
            <template #label>
                Compliance requirements
            </template>
            <template #description>
                Select the risk level associated with this {{instrumentStore.instrument.type}}
            </template>
        </cdx-field>

        <div class="rule"></div>

        <!-- REGULATION: Acknowledgement -->
        <cdx-field>
            <cdx-checkbox
                v-model="instrumentStore.instrument.acknowledgement"
                data-id="acknowledgement"
            >
            I confirm that I've followed the
            <a target="_new" class="cdx-docs-link" href="https://foundation.wikimedia.org/wiki/Legal:Data_Collection_Guidelines">data collection guidelines</a>
            and determined that this experiment is low risk, or that I have completed the necessary mitigations in case a Security and Legal review was required.
            </cdx-checkbox>
        </cdx-field>
    </div>
</template>
